/*********************************************************************/
/*                                                                   */
/*      makeType()...     1995.12.14.  Lxy.                          */
/*                                                                   */
/*********************************************************************/
#   include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "makenodes.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

PTR_TYPE
alloc_type (fi)
        PTR_FILE fi;
{
        PTR_TYPE new;

        new = (PTR_TYPE) calloc (1, sizeof (struct data_type));
        new->id = ++(fi->num_types);
        new->thread = TYNULL;
        if (fi->num_types == 1)
                fi->head_type = new;
        else
                fi->cur_type->thread = new;
        fi->cur_type = new;
        return (new);
}

/*
 * Make a new type node
 */
PTR_TYPE
make_type (fi, node_type)
        PTR_FILE fi;
        int      node_type;
{
        PTR_TYPE new_type;

        new_type = alloc_type (fi);
        new_type->entry.Template.ranges =  NULL;
        new_type->variant = node_type;
        return (new_type);
}

/* 
 *  make_type_node comes from sage++/f2dep/sym.c
 */

PTR_TYPE
make_type_node(typespec, lengspec)
PTR_TYPE typespec;
PTR_LLND lengspec;
{
     PTR_TYPE t;

     t = typespec;
     if (lengspec != LLNULL)
     {
          t = make_type(fi, typespec->variant);
          t->entry.Template.ranges = lengspec;
     }
     return (t);
}

PTR_TYPE
look_up_type(type,name)
int type;
PTR_SYMB name;
{
   PTR_TYPE t,temp,temp1;
   int flag=0;
   t=global_default;
   if(t==NULL)
	return(NULL);
   for(temp=t;(temp!=NULL)&&(flag!=1);temp=temp->thread)
						/* modified by zheng.gb */
	if((temp->variant==T_RECORD)&& (temp->name->id == name->id))
	{ flag=1;
	  temp1=temp;
	  }
   if(flag==1)
     return(temp1);
   else
     return(temp);
}
