/*******************************************************************/
/*                " make executable"                               */
/*       In this file I will perform special actions on            */
/*       each statment of executable_stmt part.                       */
/*                       Zhengqiang                                */
/*******************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "makenodes.h"
#include "extern.h"
#include "exec_part.h"
#include "decl.h"
#include <stdio.h>

#define LABEL_STACK_MAX 100
extern PTR_BLOB lastBranchEnd;

void mynop()
{
 ;
}
PTR_BFND makeAsslabBfnd(bfnd,symb_ptr,llnd1,llnd2,llnd3)
PTR_BFND         bfnd;
PTR_SYMB         symb_ptr;
PTR_LLND         llnd1,llnd2,llnd3;
{
         bfnd->entry.assign_label.null_1 = symb_ptr;
         bfnd->entry.assign_label.l_value = llnd1;
         bfnd->entry.assign_label.r_value = llnd2;
         bfnd->entry.assign_label.null_2 = llnd3;
         bfnd->entry.assign_label.cmnt_ptr = NULL;
         return(bfnd);
}

PTR_BFND makeAssgnBfnd(bfnd,symb_ptr,llnd1,llnd2,llnd3)
PTR_BFND     bfnd;
PTR_SYMB     symb_ptr;
PTR_LLND     llnd1,llnd2,llnd3;
{
         bfnd->entry.assign.null_1 = symb_ptr;
         bfnd->entry.assign.l_value = llnd1;
         bfnd->entry.assign.r_value = llnd2;
         bfnd->entry.assign.null_2 = llnd3;
         bfnd->entry.assign.cmnt_ptr = NULL;
         return(bfnd);
}

PTR_BFND makeAssgotoBfnd(bfnd,symb_ptr,llnd1,llnd2,llnd3)
PTR_BFND     bfnd;
PTR_SYMB     symb_ptr;
PTR_LLND     llnd1,llnd2,llnd3;
{
         bfnd->entry.assign_goto.goto_variable = symb_ptr;
         bfnd->entry.assign_goto.label_list = llnd1;
         bfnd->entry.assign_goto.null_2 = llnd2;
         bfnd->entry.assign_goto.null_3 = llnd3;
         bfnd->entry.assign_goto.cmnt_ptr = NULL;
         return(bfnd);
}

PTR_BFND makeGotoBfnd(bfnd,symb_ptr,llnd1,llnd2,llnd3)
PTR_BFND     bfnd;
PTR_SYMB     symb_ptr;
PTR_LLND     llnd1,llnd2,llnd3;
{
         bfnd->entry.goto_stmt.target_label = llnd3;
         return (bfnd);
}

PTR_BFND makeComGotoBfnd(bfnd,llnd1,llnd2)
PTR_BFND         bfnd;
PTR_LLND         llnd1,llnd2;
{
         bfnd->entry.computed_goto.label_list = llnd1;
         bfnd->entry.computed_goto.goto_expr = llnd2;
         return (bfnd);
}

PTR_BFND makeRetnBfnd(bfnd,expr)
PTR_BFND         bfnd;
PTR_LLND         expr;
{
         bfnd->entry.return_stmt.expr = expr;
         return(bfnd);
}

PTR_BFND makeCallBfnd(bfnd,argu_list,proc_name)
PTR_BFND     bfnd;
PTR_LLND         argu_list;
PTR_SYMB     proc_name;
{
         PTR_LLND         newll;
         newll = makeLlnd(fi,PROC_CALL,LLNULL,LLNULL,SMNULL);
         /* bfnd->entry.call.null1 = proc_name; */

         newll->entry.proc.symbol = proc_name;
         newll->entry.proc.param_list = argu_list;

         bfnd->entry.call.call_exp = newll;
         return(bfnd);
}

PTR_BFND makeSeleBfnd(bfnd,cons_name,selector)
PTR_BFND         bfnd;
PTR_SYMB         cons_name;
PTR_LLND         selector;
{
         bfnd->entry.case_stmt.construct_name = cons_name;
         bfnd->entry.case_stmt.selector = selector;
         return(bfnd);
}

PTR_BFND makeDoBfnd(bfnd,control_var,range,increment,construct_name,label)
PTR_BFND         bfnd;
PTR_SYMB     control_var;
PTR_LLND         range,increment,construct_name;
PTR_LABEL          label;
{
         bfnd->entry.do_stmt.control_var = control_var;
         bfnd->entry.do_stmt.range = range;
         bfnd->entry.do_stmt.increment = increment;
         bfnd->entry.do_stmt.construct_name = construct_name;
         bfnd->entry.do_stmt.do_label = label;
         return(bfnd);
}

                           /*   modified by zheng.gb --- del control_var */
PTR_BFND modiDoBfnd(bfnd,construct_name,label)
PTR_BFND     bfnd;
PTR_LLND     construct_name;
PTR_LABEL    label;
{
         bfnd->entry.do_stmt.construct_name = construct_name;
         bfnd->entry.do_stmt.do_label = label;
/*
         bfnd->entry.do_stmt.control_var = control_var;
*/
         return(bfnd);
}

PTR_BFND makeCaseBfnd(bfnd,cons_name,option_expr,comment)
PTR_BFND     bfnd;
PTR_SYMB     cons_name;
PTR_LLND     option_expr;
PTR_CMNT     comment;
{
         bfnd->entry.case_option.construct_name = cons_name;
         bfnd->entry.case_option.case_option_expr_list = option_expr;
         bfnd->entry.case_option.cmnt_ptr = comment;
         return(bfnd);
}

PTR_BFND makeDoWhileBfnd(bfnd,condition)
PTR_BFND     bfnd;
PTR_LLND     condition;
{
         bfnd->entry.do_while.conditional = condition;
         return(bfnd);
}

PTR_BFND makeWhereStmt(bfnd,condition)
PTR_BFND     bfnd;
PTR_LLND     condition;
{
         bfnd->entry.where_stmt.condition = condition;
         return(bfnd);
}

PTR_BFND makeWhereBfnd(bfnd,condition)
PTR_BFND     bfnd;
PTR_LLND     condition;
{
         setBlob(bfnd,pred_bfnd);
         cur_blob = make_blob(fi,BFNULL, BLNULL);
         bfnd->entry.Template.bl_ptr1 = cur_blob;
         pred_bfnd=bfnd;

         return(makeWhereStmt(bfnd,condition));
         /* because the action is the same as where_node bfnd here */
}

PTR_BFND modiWhereConsBfnd(bfnd,trueBranch,falseBranch)
PTR_BFND     bfnd;
PTR_BLOB     trueBranch,falseBranch;
{
         bfnd->entry.where_block.control_true = trueBranch;
         bfnd->entry.where_block.control_false = falseBranch;
         return(bfnd);
}

PTR_BFND  makeArithIfBfnd(bfnd,condition,labList)
/* For arithmatic if statement */
PTR_BFND     bfnd;
PTR_LLND     condition,labList;
{
         bfnd->entry.arith_if.condition = condition;
         bfnd->entry.arith_if.label_list = labList;
         return(bfnd);
}

PTR_BFND  makeLogIfBfnd(bfnd,condition,action)
/* Whose structure name is IF_STMT (variant = LOGIF_NODE ) */
PTR_BFND     bfnd;
PTR_LLND     condition;
PTR_BLOB         action;
{
         bfnd->entry.if_stmt.condition = condition;
         bfnd->entry.if_stmt.control_true = action;
         return(bfnd);
}

PTR_BFND  makeIfBfnd(bfnd,name,condition)
/* Whose structure name is IF_THEN_ELSE (variant = LOGIF_NODE) */
PTR_BFND     bfnd;
PTR_SYMB     name;
PTR_LLND     condition;
{
         bfnd->entry.if_stmt.null_1 = name;
         bfnd->entry.if_stmt.condition = condition;
         return(bfnd);
}

PTR_BFND makeElseIfBfnd(bfnd,condition,name)
/* Whose structure name is IF_ELSE_IF_STMT (variant = ELSEIF_NODE) */
PTR_BFND     bfnd;
PTR_SYMB     name;
PTR_LLND     condition;
{
         bfnd->entry.if_else_if.construct_name = name;
         bfnd->entry.if_else_if.condition = condition;
         return(bfnd);
}

void swapBlob(blob1,blob2)
PTR_BLOB blob1,blob2;
{
         PTR_BLOB p;

         p = blob1;
         blob1 = blob2;
         blob2 = p;
}

PTR_BFND makeForallBfnd(bfnd,headop,maskExpr)
PTR_BFND     bfnd;
PTR_LLND     headop,maskExpr;
{
         bfnd->entry.forall_Stat.head_exp_list = headop;
         bfnd->entry.forall_Stat.scalar_mask_expr = maskExpr;
         return(bfnd);
}

void makeSonBlob(bfnd,trueBranch)
PTR_BFND     bfnd;
int trueBranch; /* 1 if true branch and 0 if false branch*/
{
         if(trueBranch){
                  setBlob(bfnd,pred_bfnd);
                  cur_blob = make_blob(fi,BFNULL, BLNULL);
                  bfnd->entry.Template.bl_ptr1 = cur_blob;
         }
         else{
                  cur_blob = make_blob(fi,BFNULL, BLNULL);
                  bfnd->entry.Template.bl_ptr2 = cur_blob;
         }
         pred_bfnd=bfnd;
}

void makeRSonBlob(bfnd)
PTR_BFND     bfnd;
{
         setBlob(bfnd,pred_bfnd);
         cur_blob = make_blob(fi,BFNULL, BLNULL);
         bfnd->entry.Template.bl_ptr2 = cur_blob;
         pred_bfnd=bfnd;
}

PTR_BFND makeAllocBfnd(bfnd,list,stat)
PTR_BFND     bfnd;
PTR_LLND     list,stat;
{
         /* The variant of the bfnd should be ALLOCATE_STMT,
   while the name of the structure is heap */

         bfnd->entry.heap.list = list;
         bfnd->entry.heap.stat = stat;
         return(bfnd);
}

PTR_BFND makeExitBfnd(bfnd,name)
PTR_BFND     bfnd;
PTR_SYMB     name;
{
         bfnd->entry.exit_stmt.construct_name = name;
         return(bfnd);
}

PTR_BFND makeStopBfnd(bfnd,code)
PTR_BFND     bfnd;
PTR_LLND     code;
{
         bfnd->entry.stop.stop_code = code;
         return(bfnd);
}


PTR_BFND makeNulfyBfnd(bfnd,list)
PTR_BFND     bfnd;
PTR_LLND     list;
{
         bfnd->entry.nullify.list = list;
         return(bfnd);
}

PTR_BFND makeAssoBfnd(bfnd,pointer_object,target_pointer1,result)
PTR_BFND     bfnd;
PTR_LLND     pointer_object,target_pointer1,result;
{
         bfnd->entry.associated_stat.pointer_object = pointer_object;
         bfnd->entry.associated_stat.target_pointer = target_pointer1;
         bfnd->entry.associated_stat.result = result;
         return(bfnd);
}

PTR_BFND makeBackspceBfnd(bfnd,exFile,posSpecList)
PTR_BFND     bfnd;
PTR_LLND     exFile,posSpecList;
{
         bfnd->entry.backspace_stat.file_expr = exFile;
         bfnd->entry.backspace_stat.posit_list = posSpecList;
         return(bfnd);
}

PTR_BFND makeOpenBfnd(bfnd,openSpecLst)
PTR_BFND     bfnd;
PTR_LLND     openSpecLst;
{
        bfnd->entry.open_stat.control = openSpecLst;
        return(bfnd);
}

PTR_BFND makeCloseBfnd(bfnd,closSpecLst)
PTR_BFND     bfnd;
PTR_LLND     closSpecLst;
{
         bfnd->entry.close_stat.control = closSpecLst;
        return(bfnd);
}

PTR_BFND makeInquireBfnd(bfnd,specList,length,outputItem)
PTR_BFND     bfnd;
PTR_LLND     specList,length,outputItem;
{
         bfnd->entry.inquire_stat.spec_list = specList;
         bfnd->entry.inquire_stat.length = length;
         bfnd->entry.inquire_stat.output_item = outputItem;
        return(bfnd);
}

PTR_BFND makeFmtBfnd(bfnd,format)
PTR_BFND     bfnd;
PTR_LLND     format;
{
        bfnd->entry.format_stat.format = format;
        return(bfnd);
}

PTR_LLND makeLlVarRef(llnd, ll1, ll2, symb_ptr)
PTR_LLND llnd,ll1,ll2;
PTR_SYMB symb_ptr;
{
         /* In Var_Ref llnd left sub_tree and right sub_tree are all empty */
         llnd->entry.var_ref_s.symbol = symb_ptr;
         return (llnd);
}

PTR_LLND makeLlExpLst(llnd,ll1,ll2,symb_ptr)
/* To attach ll1 to the end of the chain headed by ll2. */
PTR_LLND llnd,ll1,ll2;
PTR_SYMB symb_ptr;
{
         PTR_LLND tempLlnd,headll2;

         llnd->entry.list.item = ll1;
         llnd->entry.list.next = LLNULL;
         if (!ll2)
                  return (llnd);

         headll2 = ll2;
         while(ll2->entry.list.next) {
                  ll2 = ll2->entry.list.next;
         }
         ll2->entry.list.next = llnd;
         return (headll2);
}

PTR_LLND makeLblLst(fi,node_type,lstHead,lab)
PTR_FILE          fi;
int                   node_type;
PTR_LLND          lstHead;
PTR_LABEL         lab;
{
         PTR_LLND new_llnd,p;

         new_llnd = alloc_llnd (fi);     /* should set up id field */

         new_llnd->variant = node_type;
         new_llnd->type = TYNULL;

         new_llnd->entry.label_list_s.null_1 = LLNULL;
         new_llnd->entry.label_list_s.next = LLNULL;
         new_llnd->entry.label_list_s.lab_ptr = lab;

         if(lstHead){
                  for (p = lstHead; p->entry.label_list_s.next; p = p->entry.label_list_s.next)
                           ;
                  p->entry.label_list_s.next = new_llnd;
                  return(lstHead);
         }
         else
                  return (new_llnd);
}

PTR_LLND makeLlLablst(llnd,ll1,ll2,label_ptr)
PTR_LLND  llnd,ll1,ll2;
PTR_LABEL label_ptr;
{
         PTR_LLND tempLlnd,headll1;

         llnd->entry.label_list.lab_ptr = label_ptr;
         llnd->entry.label_list.next = LLNULL;
         if (!ll1)
                  return (llnd);

         headll1 = ll1;
         while(ll1->entry.list.next) {
                  ll1 = ll1->entry.label_list.next;
         }

         ll1->entry.list.next = llnd;
         return (headll1);
}

PTR_BFND makeCycleBfnd(bfnd,symb_ptr)
PTR_BFND bfnd;
PTR_SYMB symb_ptr;
{
         bfnd->entry.cycle.construct_name = symb_ptr;
         return(bfnd);
}

PTR_BFND makeEndBfnd(bfnd,symb_ptr)
PTR_BFND bfnd;
PTR_SYMB symb_ptr;
{
         bfnd->entry.contol_end.control_name = symb_ptr;
         return(bfnd);
}

PTR_BFND makeChldHead(parent,lChild,rChild)
PTR_BFND parent,lChild,rChild;
{
         PTR_BLOB tBranch,fBranch;

         tBranch = alloc_blob1(fi);
         parent->entry.Template.bl_ptr1 = tBranch;
         tBranch->ref = lChild;

         if (rChild)
         {
                  fBranch = alloc_blob1(fi);
                  parent->entry.Template.bl_ptr2 = fBranch;
                  fBranch->ref = rChild;
         }
         else
         {
                  parent->entry.Template.bl_ptr2 = BLNULL;
         }

         /* cur_blob = parent; */

         return(parent);
}

/* Function : attach a new node to the end of a list.
   Input : the head of the list, the new node and an indicator
           indicates the list is its control parent's true 
           branch or false branch.
   Output : the head of the list
*/
PTR_BFND lnkLst(head,newNode,branch)
PTR_BFND head,newNode;
int branch; /* 1 if true branch and 0 if false branch */
{
         PTR_BLOB p,q;

         if (branch = 1)
                  p = head->control_parent->entry.Template.bl_ptr1;
                  /* point to the head of true branch */
         else
                  p = head->control_parent->entry.Template.bl_ptr2;
         /* point to the head of false branch */

         for(;p = p->next;p->next)
                  ;

         p->next = make_blob(fi,newNode,BLNULL);
         newNode->control_parent = p->ref->control_parent;

         cur_blob = cur_blob->next;

         return(head);
}

PTR_BFND makeElseBranch(parent,lBranch,rBranch,endStmt)
PTR_BFND parent,lBranch,rBranch,endStmt;
{
         PTR_BLOB p;
         PTR_BFND bf;

         if(rBranch != BFNULL)
         {
                  p = lastBranchEnd->next;
                  parent->entry.Template.bl_ptr2 = p;

                  bf = makeBfnd(fi,CONTROL_END);
                  lastBranchEnd->next = make_blob(fi,bf,BLNULL);
                  bf->control_parent = parent;
         }

         return(parent);
}

/*
   find the blob to a certain bfnd, return nil if fail
*/
PTR_BLOB findBlob(bfnd)
PTR_BFND bfnd;
{
         PTR_BLOB p;

         for(p = bfnd->control_parent->entry.Template.bl_ptr1;
             p && p->ref != bfnd; p = p->next)
                  ;

         /* donot forget to find the bfnd in the second BLOB ,add by zheng.gb */
         if (!p)
                  for(p = bfnd->control_parent->entry.Template.bl_ptr2;
                  p && p->ref != bfnd; p = p->next)
                  ;

         if (!p)
                  return(BLNULL);
         else
                  return(p);
}

PTR_LABEL locateLab(label)
long label;
{
         PTR_LABEL p;

         if (fi->num_label == 0)
                  return(LBNULL);

         for(p = fi->head_lab; p ; p = p->next)
                  if (p->stateno == label)
                           return(p);

         return (LBNULL);
}

static int labelStackTop_g;
static int labelStack_g[LABEL_STACK_MAX];
/* The following functions are all about label stack . */

void initLblStack()
{
         labelStackTop_g = -1;
}

long lblStackTop()
{
         if(labelStackTop_g >= 0)
                  return labelStack_g[labelStackTop_g];
         else
                  return 0;
}

int inLblStack(label)
long label;
{
         int i;
         if (labelStackTop_g >= 0){
                  for(i = 0; i < labelStackTop_g; i++)
                           if (labelStack_g[i] == label)
                                    return(1);
         }

         return (0);
}

void popLblStack()
{
         if (labelStackTop_g >= 0)
                  --labelStackTop_g;
         else
         {
                  printf("Label stack empty ! ");
                  exit(1);
         }
}

void pushLblStack(endLabel)
long endLabel;
{
         if ( ++labelStackTop_g <= LABEL_STACK_MAX - 1)
                  labelStack_g[labelStackTop_g] = endLabel;
         else{
                  printf("Label stack full ! ");
                  exit(1);
         }
}

int stackHeight()
{
         return(labelStackTop_g + 1);
}

int emptyLblStack()
{
         return((labelStackTop_g == -1 ? 1 : 0));
}

/* Used only after the endprogram or endfunction statement is met ,
   In order to judge if a label do construction ends up in a module */

void lblDoErrSearch()
{
        int i;

        if (!emptyLblStack()) {

        for(i = 0; i <= labelStackTop_g; i++)
        printf("Referenced label %d in label do statement not appeared in a statement ! \n",labelStack_g[i]);

        initLblStack();
        }
}

                                    /* modified by zheng.gb  add PTR_BFND*/
PTR_BFND lnkStmts(oldList,newLabel,newStmt,comment)
PTR_BFND   oldList,newStmt;
PTR_LABEL  newLabel;
PTR_CMNT   comment;
{
PTR_BFND   p,newList;
/* int            innerest; */

         if (oldList) newList = oldList ;/* add by zheng.gb */
         newStmt->entry.Template.cmnt_ptr = comment;
         newStmt->label = newLabel;
         if(newLabel)
                  newLabel->statbody = newStmt;

         if((newStmt->variant!= WHERE_BLOCK_STMT)&&(newStmt->variant!= SWITCH_NODE)
             &&(newStmt->variant!= FOR_NODE)&&(newStmt->variant!= IF_NODE)
             &&(newStmt->variant!= FORALL_CONSTRUCT_STMT)&&(newStmt->variant!= LOGIF_NODE)&&(newStmt->variant!= LOGIF_STMT)
             &&(newStmt->variant!= ELSEIF_NODE)&&(newStmt->variant!= WHILE_NODE)
             &&(newStmt->variant!= DO_WHILE_NODE)&&(newStmt->variant!= FORALL_STMT)&&(newStmt->variant!= WHERE_NODE)) /* &&(newStmt->variant!=TASK_STMT)) */
                  newList = setBfndList(oldList,newStmt);
         if (newLabel){
                  /* innerest = 1; */
                  while ( newLabel->stateno == lblStackTop() ) {
                         /* add CONTROL_END to every do_construct  zheng.gb 1996.5.4 */
                           p = makeEnd(fi);
                        --(p->g_line); --(p->l_line);
                           setBfndList(newList,p); 
/* HIT */
/*
                              ++end_group;
                              close_groups(); *//* complete the current list of sons of label_do stmt and make the current parent bfnd be the parent of label_do stmt */
                           popLblStack();
                  }
                  if (inLblStack(newLabel->stateno)) {
                           printf("line: %d  syntax error:loop mismatch \n",lineNum_g);
                           exit(1); 
                  } 
         } 
         return newList;
}

