/****************************************************************/
/*                                                              */
/*       Function specification used in  libbasic.a             */
/*              11.30 1995    Lxy.                              */
/*                                                              */
/****************************************************************/

PTR_BFND makeBfnd();       /* in file "makebfnd.c" */
PTR_LLND makeLlnd();	   /* in file "makellnd.c" */
PTR_SYMB makeSymb ();	   /* in file "makesymb.c" */
PTR_SYMB makeSymbVar(); 
PTR_SYMB make_symb();
PTR_SYMB lookupSymb();
PTR_SYMB lookupSymbglobal();
char *copys();
void err_g();
void init_scope_table();
PTR_BFND cur_scope();
PTR_BFND parent_scope();
void add_scope_level();
void delete_beyond_scope_level();
int cur_scope_level();
void setBlob();		   /* in file "makeblob.c" */
PTR_BLOB make_blob ();
PTR_BFND setBfndList();    /* in file "makelist.c" */
PTR_LLND set_ll_list();
PTR_SYMB set_id_list();
PTR_LLND add_to_lowLevelList();
PTR_LLND add_to_lowList();
PTR_TYPE make_type();	   /* in file "maketype.c" */
PTR_TYPE make_type_node();
PTR_TYPE look_up_type();
PTR_LABEL make_label();    /* in file "makelabel.c" */
PTR_LLND make_llnd_label();
PTR_LLND alloc_llnd();
PTR_BLOB alloc_blob1();
PTR_BFND makeEnd();


/* added temporaryly */


#define BFNULL          (PTR_BFND)  0
#define LLNULL          (PTR_LLND)  0
#define BLNULL          (PTR_BLOB)  0
#define SMNULL          (PTR_SYMB)  0
#define HSNULL          (PTR_HASH)  0
#define TYNULL          (PTR_TYPE)  0
#ifndef LBNULL
#define LBNULL          (PTR_LABEL) 0
#define CMNULL          (PTR_CMNT)  0 
#endif

extern PTR_BFND last_bfnd;      /* it is uesd for bfnd'thread */
extern  int lineNum_g,lineNum_l;
extern PTR_FNAME head_file,cur_thread_file;   /* used in the files of  */

#define HARD                    1
#define SOFT                    0

extern PTR_BFND scope_table[1000];
extern PTR_BFND global_bfnd;



extern int top_scope_level;
extern int scope_starts[10];

extern int top_scope_starts;

extern PTR_BFND global_bfnd;
extern int top_scope_level;
extern int scope_starts[10];

extern int top_scope_starts;

extern PTR_BFND global_bfnd;

extern  int globeErr;
extern  int globeErr_g;

extern int implicitNone_g;

extern PTR_TYPE impltype[26*2];

extern int containsNum_g;

extern PTR_FILE fi;

extern PTR_BLOB cur_blob;
extern int      end_group;
extern PTR_BFND pred_bfnd;      /* used in finding the predecessor */
extern PTR_TYPE global_default;

extern int      keyword_flag;   /* zheng.gb */
