/*********************************************************************/
/*                                                                   */
/*      makeLlnd()...     1995.11.17.  Lxy.                          */
/*                                                                   */
/*********************************************************************/
# include "tags.h"
#   include "typedef.h"

#   include "bif.h"

#   include "ll.h"

#   include "symb.h"
#include "makenodes.h"

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

PTR_LLND
alloc_llnd (fi)
        PTR_FILE fi;
{
        register PTR_LLND new;

        new = (struct llnd *) chkalloc(sizeof(struct llnd));
        new->id = ++(fi->num_llnds);
        new->thread = LLNULL;
        if (fi->num_llnds == 1)
                fi->head_llnd = new;
        else
                fi->cur_llnd->thread = new;
        fi->cur_llnd = new;
        return (new);
}


PTR_LLND 
makeLlnd(fi, node_type, ll1, ll2, symb_ptr)
   PTR_FILE fi;
   int      node_type;
   PTR_LLND ll1, ll2;
   PTR_SYMB symb_ptr;
{
        PTR_LLND new_llnd;

        new_llnd = alloc_llnd (fi);     /* should set up id field */

        new_llnd->variant = node_type;
        new_llnd->type = TYNULL;
	new_llnd->attr=0;				/* add by zheng.gb */
        new_llnd->const_val=0;                          /* add by zheng.gb */


        new_llnd->entry.Template.ll_ptr1 = ll1;
        new_llnd->entry.Template.ll_ptr2 = ll2;

        switch (node_type) {
          case INT_VAL:
            new_llnd->entry.ival = (int) symb_ptr;
            break;
          case BOOL_VAL:
            new_llnd->entry.bval = (int) symb_ptr;
            break;
	/*
          case FLOAT_VAL:
          case DOUBLE_VAL:
            new_llnd->entry.dval = (double)symb_ptr;
            break;
          case CHAR_VAL:
            new_llnd->entry.cval = (char) symb_ptr;
            break;
          case STRING_VAL:
            new_llnd->entry.string_val = (char*) symb_ptr;
            break;
	*/
        /*
          case KEYWORD_VAL:
        */
          default:
            new_llnd->entry.Template.symbol = symb_ptr;
            break;
          }
        return (new_llnd);
}
