/*********************************************************************/
/*                                                                   */
/*      makeLlnd()...     1995.11.17.       ZhongJiDong              */
/*                                                                   */
/*********************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "extern.h"
#include "decl.h"
#include <stdio.h>

PTR_LLND
fdalloc_llnd (fi)
PTR_FILE fi;
{
        register PTR_LLND new;

	/* to alloc a struct	*/
        new = ALLOC (llnd);

	/* to initial it	*/
	new->variant=0;
        new->id = ++(fi->num_llnds);
        new->thread = NULL;
	new->type=NULL;

	/* to link it to the thread	*/
        if (fi->num_llnds == 1)
                fi->head_llnd = new;
        else
                fi->cur_llnd->thread = new;
        fi->cur_llnd = new;
        return (new);
}


PTR_LLND 
fdmakellnd(fi, node_type, ll1, ll2, symb_label_char_ptr,value)
PTR_FILE fi;
int      node_type;
PTR_LLND ll1, ll2;
PTR_SYMB symb_label_char_ptr;  	/* if the node_type is "COMPLEX_VAL" ...
					this is PTR_SYMB
				   if the node_type is "LABEL_LIST" ...
					this is PTR_LABEL
				   if the node_type is "STRING_VAL" ...
					this is char*  
				*/
double value;
				/* if the node_type is "INT_VAL"
					this is int ,should be given to
					"entry.ival" 
				   if the node_type is "BOOL_VAL"
					this is int ,should be given to
					"entry.bval"
				   if the node_type is "FLOAT_VAL""DOUBLE_VAL"
					this is double ,should be given to
					"entry.dval"
				   if the node_type is "CHAR_VAL"
					this is char ,should be given to 
					"entry.cval"
				   if the node_type is "ARRAY_OP"
					this is int ,should be given to
					"entry.array_op.dim"
				   in orther conditions ,this is useless
				*/

	
{
        PTR_LLND new_llnd;

	/* to alloc a initialed struct	*/
        new_llnd = fdalloc_llnd (fi);   

	/* now to add contents to the struct	*/
        new_llnd->variant = node_type;

        switch (node_type) {
          	case INT_VAL:
            		new_llnd->entry.ival = (int) value;
            	break;
          	case BOOL_VAL:
            		new_llnd->entry.bval = (int) value;
            	break;
          	case FLOAT_VAL:
          	case DOUBLE_VAL:
            		new_llnd->entry.dval = (double) value;
            	break;
          	case CHAR_VAL:
            		new_llnd->entry.cval = (char) value;
            	break;

          	case STRING_VAL:
            		new_llnd->entry.string_val = (char*) symb_label_char_ptr;
            	break;

		case ARRAY_OP:
			new_llnd->entry.array_op.symbol=symb_label_char_ptr;
			new_llnd->entry.array_op.dim=(int) value;
		break;
		
		/* in other cases	*/
           	default:
            		new_llnd->entry.Template.symbol = symb_label_char_ptr;
			new_llnd->entry.Template.ll_ptr1= ll1;
			new_llnd->entry.Template.ll_ptr2= ll2;
           	break;
        }

	return (new_llnd);
}


fdaddtolllist(ll_top,ll_low)
PTR_LLND  ll_top,ll_low ;

{
	PTR_LLND  ll;

	ll=ll_top->entry.Template.ll_ptr2;

	if(!ll)
	{
		ll_top->entry.Template.ll_ptr2=ll_low;
	}
	else
	{
		while(ll->entry.Template.ll_ptr2)
			ll=ll->entry.Template.ll_ptr2;

		ll->entry.Template.ll_ptr2=ll_low; 
	}

}
