#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include"tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "makenodes.h"
#include <stdio.h>
#include "extern.h"

/********  Fill in bif-node of  read-statmemnt   ********/
PTR_BFND makeReadBfnd(bfnd,formt,control_list,expr_list)
PTR_BFND bfnd;
PTR_LLND formt,control_list,expr_list;
{
   bfnd->entry.read_stat.format = formt;
   bfnd->entry.read_stat.var_list = expr_list;
   bfnd->entry.read_stat.control_list = control_list;
   return(bfnd);
}

PTR_BFND makeWriteBfnd(bfnd,expr_list,control_list)
PTR_BFND bfnd;
PTR_LLND expr_list,control_list;
{
  bfnd->entry.write_stat.expr_list = expr_list;
   bfnd->entry.write_stat.control_list = control_list;
   return(bfnd);
}

/*********  Append a llnd-list **********/ 
PTR_LLND
AppendllndList(llndlist,llnd)
PTR_LLND llndlist,llnd;
{
   PTR_LLND llhead;
   llhead = llndlist;
   for(;llndlist->entry.list_s.next;llndlist = llndlist->entry.list_s.next)
     printf("+++++++++++++\n"); 
	 /* Get to the end of the list*/
    llndlist->entry.list_s.next = llnd;
   return(llhead);
}

/* PTR_LLND makeLlExpLst(llnd,ll1,ll2,symb_ptr)
   PTR_LLND llnd,ll1,ll2;
   PTR_SYMB symb_ptr;
{
   PTR_LLND tempLlnd,headll2;
   llnd->entry.list.item = ll1;
   llnd->entry.list.next = LLNULL;
   if (!ll2)
      return (llnd);
   headll2 = ll2;
   while(ll2->entry.list.next) {
      ll2 = ll2->entry.list.next;
   }
   ll2->entry.list.next = llnd;
   return (headll2);
}

*/



/************Fill in   bif-node of Print-statmemnt  ************/

PTR_BFND makePrintBfnd(bfnd,formt,expr_list)
PTR_BFND bfnd;
PTR_LLND formt,expr_list;
{
   bfnd->entry.print_stat.expr_list = expr_list;
   bfnd->entry.print_stat.format = formt;
   return(bfnd);
}


/************ Append  a llnd to a llnd-list ************/

PTR_LLND assignllnd(llnd1,llnd2)
PTR_LLND llnd1,llnd2;
  {
      llnd1=llnd2;
      return(llnd1);
  }

PTR_LLND 
appendImpliedDoList(llnd1,llnd2)
PTR_LLND llnd1,llnd2;
 {PTR_LLND llhead;
   llhead = llnd1;
   for(;llnd1->entry.list_s.next != NULL;llnd1 = llnd1->entry.list_s.next)
      ; /* Get to the end of the list*/
    llnd1->entry.list_s.next = llnd2;
   return(llhead);
  }

