/*****************************************************************************
written
	by Zheng Gengbin

******************************************************************************/

typedef struct _bfnd_list {
	PTR_BFND bfnd;
	struct _bfnd_list *next;
}  *BFND_LIST;

typedef struct _symbol_list {
	PTR_SYMB sym;
	struct _symbol_list *next;
}  *SYMB_LIST;

typedef struct _type_list {
        PTR_TYPE type;
        struct _type_list *next;
}  *TYPE_LIST;

typedef struct _llnd_list {
        PTR_LLND llnd;
        struct _llnd_list *next;
}  *LLND_LIST;


typedef struct _binary_mod_tree {
	struct _binary_mod_tree *lp, *rp;
	char			*name;
} *PTR_MOD;


/* flag bit of g_state */
#define IS_PARAMETER_BIT 		0x2
#define NEED_INITIALIZATION_EXPR_BIT  	0x4
#define IS_VARIABLE			0x8
#define NEED_SPECIFICATION_EXPR_BIT  	0x10
#define INITIALIZATION_EXPR_ASSIGN      0x20
#define IO_IMPDO                        0x40

#define NON_PURE			100
#define PURE_FUNC			200
#define PURE_PROC			300          
						/* FORALL */
#define FORALL_IN                       400
#define FORALL_PURE_FUNC		500
#define FORALL_PURE_PROC		600

#define HAS_USE                         0x1
#define HAS_IMPLICIT_NONE               0x2
#define HAS_IMPLICIT                    0x4

	/* some flag to avoid repetitive check */
#define CHECKED_EXPR_TYPE	ENTRY_BIT         /* also check_expr_type */
#define COUNTED_BINARY  	DEFINED_OPERATOR_BIT /*also count binary flag */
#define CHECKED_LEAF_SYMB       DEFINED_ASSIGNMENT_BIT
#define COUNTED_EXPR            INTERFACE_BIT
#define GOT_KIND                PURE_BIT

/* flag for checked in bfnd other than soft hard other than SOFT , HARD */
/*#define  VIRTUAL_BFND           2       for module bfnd load from mod files */


#define MAGIC_NO	0421
