/*wzl*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"

#define  s_bool   1
#define  s_int0   4
#define  s_int1   2
#define  s_int2   8
#define  s_real0  4
#define  s_real1  8
#define  s_real2  16
#define  s_double 8


/*rerturn the size of type*/
int type_size(type)
PTR_TYPE type;
{
  int size,i,dims,symb_size;
  int up[7],down[7],tag[7];

  switch (type->variant) {
     case T_INT:
            return s_int0;
     case T_FLOAT:
            return s_real0;
     case T_BOOL:
            return s_bool;
     case T_RECORD:
             size = 0;
             for (i=0;i<type->entry.re_decl.num_fields;i++) {
                size += type_size(type->entry.re_decl.first->type);
                type = type->entry.re_decl.first->entry.field.next->type; 
             }
     case T_COMPLEX:
             return 2*s_real0;
     case T_ARRAY:
             /* get_bound_of_array(type,down,up,tag,&dims); */
	     dims=type->entry.ar_decl.num_dimensions;
             symb_size=type_size(type->entry.ar_decl.base_type);
             for (i=0;i<dims;i++){
		int lbound , ubound;
		if (get_array_lbound(type,i+1,&lbound)==0 ||
			get_array_ubound(type,i+1,&ubound)==0 )
		{
			printf("Can not get size of array type !\n");
			return -1;
		}
                 if (ubound>lbound)
                   symb_size*= ubound-lbound+1;
             } 
             return(symb_size);
    case T_STRING:
             return -1;
  }
}
