#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "exglobal.h"
#include "decl.h"
#include "extern.h"

extern int debug1;
void	check_io_control();

int	open_close()
{	PTR_BFND	thisbfnd=cur_bfnd;
	PTR_LLND 	connec_spec_list=thisbfnd->entry.Template.ll_ptr1;
	PTR_LLND	connec_spec,keyword,p;
	char  *flag[30];


if (debug1)  printf("Here , in open_stmt .\n");
	if (connec_spec_list!=NULL)
		{ connec_spec=connec_spec_list->entry.Template.ll_ptr1;
		  keyword=connec_spec->entry.Template.ll_ptr1;
		  if (keyword==NULL)
		  {     p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
                        p->entry.string_val = (char *)"unit";
			connec_spec->entry.Template.ll_ptr1=p;
		  }
		}
	check_io_keyword(thisbfnd,connec_spec_list,flag);
	return(0);
}


int	check_io_keyword(thisbfnd,connec_spec_list,flag)
PTR_BFND        thisbfnd;
PTR_LLND        connec_spec_list;
char  *flag[30];
{
        PTR_LLND        connec_spec,keyword,expr;
        char  *str;
        int errcode,i,sequ=0,variant=thisbfnd->variant,ok=0;


        for (i=0;i<30;i++) flag[i]="";
        while (connec_spec_list!=NULL)
        {
         connec_spec=connec_spec_list->entry.Template.ll_ptr1;
        connec_spec_list=connec_spec_list->entry.Template.ll_ptr2;
        keyword=connec_spec->entry.Template.ll_ptr1;
	if (keyword==NULL)
	   { error1(580);}
	  else
	   {
        	expr=connec_spec->entry.Template.ll_ptr2;
        	str=keyword->entry.string_val;
                if (is_dup_keyword(str,flag,sequ)==1)
                                error3(581,str);
           }
	flag[sequ++]=str;
        errcode=io_keyword_type(str,expr,thisbfnd);
        switch (errcode)
             {  case 582: error3(582,str);
                          break;
                case 584:
		case 592:
		case 593: error1(errcode);
			break;
                case 583: error3(errcode,str);
                         break;

             }
        }
	if (variant==INQUIRE_STAT)
	    {	for(i=0;i<30;i++)
	 	   	if ((strncmp(flag[i],"unit",4)==0) 
				|| (strncmp(flag[i],"file",4)==0))
				{ ok++;}
		if (ok==0) error1(585);
		if (ok==2) error1(604);
	    }
	   else
		{  for(i=0;i<30;i++)
			 if (strncmp(flag[i],"unit",4)==0)
				 { ok=1;}
		   if (ok==0) error1(586);	
		}
	return(0);



}

int	is_dup_keyword(str,flag,sequ)
	/* check if the keyword of io is duplicate
	   return 0: isnot duplicate; 1: yes
	*/
char	*str,*flag[30];
int	sequ;
{	int i;
	
	for(i=0;i<sequ;i++)
		if (strcmp(str,flag[i])==0)
			return(1);
	flag[sequ++]=str;
	return(0);
}

int  io_keyword_type(str,expr,thisbfnd)
	/* ckeck if the keyword of io statement is matched with grammar,
	  rerurn 0: is matched; otherwised return errcode
	*/
char	*str;
PTR_LLND	expr;
PTR_BFND	thisbfnd;
{	
	int errcode=0,variant=thisbfnd->variant;
	
	if (strcmp(str,"unit")==0)
		{
		  if ((variant==READ_STAT) || (variant==WRITE_STAT)  
			||(variant==PRINT_STAT))
		     {  if ((expr->variant==KEYWORD_VAL)  &&  
				(strcmp(expr->entry.string_val,"*")==0))
			   {  return(0);}
				/* modified by zheng.gb 1996/12/13 */
			if (expr->variant==KIND_VAL && 
			     strcmp(expr->entry.Template.symbol->ident,"*")==0 )
			{ return 0; }
		     }
		 check_expr_type(expr);
		 if (isInteger(expr)==0)
		     {	if ((variant!=READ_STAT) && (variant!=WRITE_STAT)
                        	&& (variant!=PRINT_STAT))
			  { errcode=582; }
			  else
			    {	if (isString(expr)==0)
				    errcode=582; 
			    }
		     }
	  	}
	if ((strcmp(str,"file")==0) || (strcmp(str,"access")==0)
		|| (strcmp(str,"form")==0) || (strcmp(str,"blank")==0)
		|| (strcmp(str,"position")==0) || (strcmp(str,"action")==0)
		|| (strcmp(str,"delim")==0) ||(strcmp(str,"pad")==0)
		|| (strcmp(str,"status")==0) || (strcmp(str,"advance")==0)
		|| (strcmp(str,"name")==0) || (strcmp(str,"access")==0)
		|| (strcmp(str,"sequential")==0) || (strcmp(str,"direct")==0)
		|| (strcmp(str,"form")==0) || (strcmp(str,"formatted")==0)
		|| (strcmp(str,"unformatted")==0) || (strcmp(str,"blank")==0)
		|| (strcmp(str,"position")==0) || (strcmp(str,"action")==0)
		|| (strcmp(str,"read")==0) || (strcmp(str,"write")==0)
		|| (strcmp(str,"readwrite")==0) )
		{  check_expr_type(expr);
		  if (isString(expr)==0)
			errcode=582;
		}
	if ((strcmp(str,"iostat")==0) || (strcmp(str,"recl")==0)
		|| strcmp(str,"size")==0 || (strcmp(str,"number")==0)
		|| (strcmp(str,"nextrec")==0)) 
		{ check_expr_type(expr);
		  if (isInteger(expr)==0)
			 errcode=582;
		}
	if ((strcmp(str,"err")==0) || (strcmp(str,"eor")==0)
		|| (strcmp(str,"end")==0))
		{ if ((expr->variant!=LABEL_REF) && (expr->variant!=END_LABEL)
	             && (expr->variant!=ERR_LABEL))
			{ errcode=583;}
		    else
			{ if  (check_goto_stmt(thisbfnd,expr->entry.label_ref.lab_ptr->statbody)!=0)
				errcode=584;
						/* add by zheng.gb */
			  expr->entry.label_ref.lab_ptr->labused=1;
				/* must be a statement executable */
			  if (expr->entry.label_ref.lab_ptr->statbody &&
				is_specification_stmt(expr->entry.label_ref.lab_ptr->statbody))
			     error3(250,str);
			}

		}

        if (strcmp(str,"fmt")==0)
                {	
		  	errcode=check_io_fmt(thisbfnd,expr);
                }
        if (strcmp(str,"nml")==0)
                {	if (expr->variant!=VAR_REF)
			   { errcode=592; }
			   else
				{  if (expr->entry.Template.symbol->variant!=
					NAMELIST_GROUP_NAME)
					errcode=592 ;
				}	
		}
	if  ((strcmp(str,"exist")==0) || (strcmp(str,"opened")==0)
		|| (strcmp(str,"named")==0))
		{	check_expr_type(expr);
			if (isBool(expr)==0)
			   {	errcode=582; }
		}
	
	return(errcode);
}
		


int	check_io_fmt(thisbfnd,expr)
	/* check if "fmt" : format is correct in read,write,print statement
	   return 0: right; otherwise: errcode
	*/
PTR_LLND	expr;
PTR_LLND	thisbfnd;
{	int errcode=0;

	switch (expr->variant)
	{  case LABEL_REF: if (check_goto_stmt(thisbfnd,expr->entry.label_ref.lab_ptr->statbody)!=0)
				errcode=584;
					/* add by zheng.gb 1996.5.9 */
			expr->entry.label_ref.lab_ptr->labused=1;
			break;
	   case STRING_VAL:
			break;
	   case VAR_REF:  check_expr_type(expr);
                  	  if (isInteger(expr)==0)
                         	errcode=582;
			break;
	   case KEYWORD_VAL:
		       if (strcmp(expr->entry.string_val,"*")!=0)
			  errcode=593;
			break;
	   case KIND_VAL:
			if ((expr=expr->entry.Template.ll_ptr1)!=NULL)
			   { errcode=check_io_fmt(thisbfnd,expr);}
			break;	
	   default:  errcode=593;
			break;
	}
	return(errcode);
	
}

int read_stmt()
{	PTR_LLND        io_control_list=cur_bfnd->entry.read_stat.control_list;
	PTR_LLND	input_list=cur_bfnd->entry.read_stat.var_list;
	PTR_LLND       	format=cur_bfnd->entry.Template.ll_ptr1;
	PTR_LLND	expr_list,expr;
	int	errcode=0;

	if (io_control_list!=NULL)
	     {	check_io_control(cur_bfnd,io_control_list); }
	   else
	     {	if (format!=NULL)
		    {	errcode=check_io_fmt(cur_bfnd,format);
		        switch (errcode)
           		  {  	case 582: error1(594);
                       		   break;
                		case 584:
		                case 593: error1(errcode);
                		        break;
             		  }
		    }
	     }
	
	/* the following check input_item_list*/
        for (expr_list=input_list; expr_list ; expr_list=expr_list->entry.Template.ll_ptr2)
        {
                expr= expr_list->entry.Template.ll_ptr1;
                switch (expr->variant) {
                case IMPLIED_DO:
                        g_state = IO_IMPDO;
			top_implied_do=-1;
                        checkIMPDO(expr);
                        g_state = 0;
                        break;
                default:
                        check_expr_type(expr);
                        break;
                } 
	}
}


void	        check_io_control(thisbfnd,io_list)
PTR_BFND	thisbfnd;
PTR_LLND	io_list;
{
	PTR_LLND	io_control_list=io_list;
	PTR_LLND        io_control,keyword,p,q;
	int	sequ=0,ok=1,i;
	char	*flag[30];

	/* detect which keyword is omitted*/
	while ((io_control_list!=NULL) && (sequ++<2))
	{	io_control=io_control_list->entry.Template.ll_ptr1;
                  keyword=io_control->entry.Template.ll_ptr1;
                  if (keyword==NULL)
		    	   {	if (sequ==1)
				{
                       		 p = makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
                        	 p->entry.string_val = (char *)"unit";
				 io_control->entry.Template.ll_ptr1=p;
				 q=io_control->entry.Template.ll_ptr2;
				 if (q->variant==LABEL_REF)
				    {	
					q->entry.ival=q->entry.label_ref.lab_ptr->stateno;
					q->variant=INT_VAL;
					q->type=global_int;
				    }

				}
				   else
					{ 
                   			 q= makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
                        		 q->entry.string_val = (char *)"fmt";

					 io_control->entry.Template.ll_ptr1=q;
					  /* Here must destell "fmt" amd "nml"*/
					}
			  }
	  	    else
			{  ok=0; }
			
	io_control_list=io_control_list->entry.Template.ll_ptr2;
	 }

	/* check the type of expr is matched with keyword? */
	io_control_list=io_list;
	check_io_keyword(thisbfnd,io_control_list,flag);
	
	/* check specfic conflict between io keywords*/
	ok=0;
	for (i=0;((i<30) && (strcmp(flag[i],"")!=0));i++)
	   {
		if ((ok==0) && (strcmp(flag[i],"fmt")==0))  ok=1;
                if ((ok==0) && (strcmp(flag[i],"nml")==0))  ok=2;
		if (((ok==2) && (strcmp(flag[i],"fmt")==0)) 
			||  ((ok==1) && (strcmp(flag[i],"nml")==0)))
			error1(588);
	   }
        ok=0;
        for (i=0;((i<30) && (strcmp(flag[i],"")!=0));i++)
	  { 	if ((ok==0) && (strcmp(flag[i],"rec")==0))  ok=1;
		if ((ok==0) && (strcmp(flag[i],"end")==0))  ok=2;
		if ((ok==0) && (strcmp(flag[i],"nml")==0))  ok=2;
		if ((ok==2) && (strcmp(flag[i],"rec")==0)) error1(589);
		if (((ok==1) && ((strcmp(flag[i],"end")==0) 
		    ||(strcmp(flag[i],"nml")==0))) || ((ok==2) 
			&& (strcmp(flag[i],"rec")==0)))
			error1(589);
	  }
        ok=0;
        for (i=0;((i<30) && (strcmp(flag[i],"")!=0));i++)
	  {	if ((ok==0) && (strcmp(flag[i],"eor")==0))  ok=1;
		if ((ok==0) && (strcmp(flag[i],"advance")==0))  ok=2;
		if ((ok==1) && (strcmp(flag[i],"advance")==0))  ok=2;
	  }
	if (ok==1)	error1(590);
	ok=0;
        for (i=0;((i<30) && (strcmp(flag[i],"")!=0));i++)
	  {	if  (strcmp(flag[i],"fmt")==0)  ok=2;
		if ((ok==0) && (strcmp(flag[i],"advance")==0))  ok=1;
		if (ok==1)  error1(591);
	  }
	return;
}

int write_stmt()
{       PTR_LLND        io_list=cur_bfnd->entry.write_stat.control_list;
        PTR_LLND        output_list=cur_bfnd->entry.write_stat.expr_list;
	PTR_LLND        expr,expr_list;
	extern PTR_TYPE implied_do_type;

	check_io_control(cur_bfnd,io_list);
	for (expr_list=output_list; expr_list ; expr_list=expr_list->entry.Template.ll_ptr2) 
	{
		expr= expr_list->entry.Template.ll_ptr1;
		switch (expr->variant) {
		case IMPLIED_DO:
			g_state = IO_IMPDO;
			top_implied_do=-1;
			checkIMPDO(expr);
			g_state = 0;
			break;
		default:
			check_expr_type(expr);
			break;
		}  /* switch */
	}
}


int	 print_stmt()
{
        PTR_LLND        format=cur_bfnd->entry.Template.ll_ptr1;
	int	errcode;

	if (format!=NULL)
           {   errcode=check_io_fmt(cur_bfnd,format);
               switch (errcode)
               {     case 582: error1(594);
                            break;
                      case 584:
                      case 593: error1(errcode);
                            break;
                }
	   }
}

int	backspace_endfile_rewind_stmt()
{	PTR_LLND	external_file=cur_bfnd->entry.Template.ll_ptr1;
	PTR_LLND	position_list=cur_bfnd->entry.Template.ll_ptr2;
	PTR_LLND	position_spec,keyword,p;
	char	*flag[30];
	
	if (position_list!=NULL)
	   {	/*detect if "unit" is omitted*/
		position_spec=position_list->entry.Template.ll_ptr1;
		keyword=position_spec->entry.Template.ll_ptr1;
		if (keyword==NULL)
		  {
                   p= makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
                        p->entry.string_val = (char *)"unit";
		   position_spec->entry.Template.ll_ptr1=p;

		  }
		/* check positon_spec*/
		check_io_keyword(cur_bfnd,position_list,flag);
	   }
	   else
	    {	if (external_file!=NULL)
		  {	check_expr_type(external_file);
			if (isInteger(external_file)==0)
			   {  	error3(582,"unit");
			   }
		  }
	    }
	
}

int	inquire_stmt()
{
	PTR_LLND 	inquire_list=cur_bfnd->entry.Template.ll_ptr1;
	PTR_LLND	iolength;
	PTR_LLND	output_list=cur_bfnd->entry.Template.ll_ptr3;
	PTR_LLND	inquire_spec,keyword,p;
	PTR_LLND        spec_pair,expr_list,expr;
	char	*flag[30];
	
	if (inquire_list!=NULL)
	  {	inquire_spec=inquire_list->entry.Template.ll_ptr1;
		keyword=inquire_spec->entry.Template.ll_ptr1;
		if (keyword==NULL)
		  { 	
                     p= makeLlnd(fi,KEYWORD_VAL,LLNULL,LLNULL,SMNULL);
                     p->entry.string_val = (char *)"unit";
		     inquire_spec->entry.Template.ll_ptr1=p;

		  }	
		check_io_keyword(cur_bfnd,inquire_list,flag);
	  }
	   else
      	     {  
		spec_pair=cur_bfnd->entry.Template.ll_ptr2;
		iolength=spec_pair->entry.Template.ll_ptr2;
		if  (iolength!=NULL)
		  { 	check_expr_type(iolength);
			if (isInteger(iolength)==0)
			   { error3(582,"iolength");	}
		  }
		/* ckeck the output_item*/
        	for (expr_list=output_list; expr_list ; expr_list=expr_list->entry.Template.ll_ptr2)
        	{
                  expr= expr_list->entry.Template.ll_ptr1;
                  switch (expr->variant) 
			{
                  	case IMPLIED_DO:
                        	g_state = IO_IMPDO;
				top_implied_do=-1;
                        	checkIMPDO(expr);
                        	g_state = 0;
                        	break;
                  	default:
                        	check_expr_type(expr);
                        	break;
                	}
        	}


	     }
		

}

