/*********************************************************************/
/*                                                                   */
/*    main program...     1995.11.17.  Lxy.                          */
/*                                                                   */
/*********************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#if HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif

#include <stdio.h>
#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "makespec.h"
#include "decl.h"

#include "makenodes.h"

#ifndef WIFEXITED
# define WIFEXITED(stat_val) (((stat_val) & 255) == 0)
#endif

#ifndef WEXITSTATUS
# define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
#endif

/*
 *    Global variables specification
 */

int  globeErr_g,debugFlag_g,intrFlag_g=0;
int  lineNum_g,lineNum_l;
char *outname;
char *lstname;				/* add by zheng.gb file.lst */
char *input_file;
FILE *inf_ptr;

PTR_BFND  global_bfnd;
PTR_BFND  pred_bfnd,last_bfnd;
PTR_FILE  cur_file,fi;
PTR_BLOB  cur_blob;
PTR_FNAME head_file,cur_thread_file;
int       num_files;
int       end_group;
int       language;

PTR_TYPE  global_int, global_float, global_double, global_char,
	  global_string, global_bool, global_complex, global_dcomplex,
	  global_default,global_byte,global_short,global_long;
PTR_TYPE  global_processors, global_template; /* added by WZL-LY, 03-14 */

PTR_TYPE vartype;
int      type_options;  
 PTR_TYPE impltype[26*2]; 

int derived_l;      /* used to sum the num of fields of record .  */ 
PTR_SYMB basename_l;

int derivedTypeFlag_g;

int implicitNone_g; 
int containsNum_g;


/* used to set relative_linenum lineNum_l */
int line_l[FUNC_SUB_NUM];
int lineIndex_l=0;

/* Scope table variables */
PTR_BFND scope_table[1000];
int top_scope_level;
int scope_starts[10];
int top_scope_starts;

int cc_flag=0;              /* multi file compilation mode flag */

PTR_BLOB lastBranchEnd;

char     *tempfile;

void clear_tmp()
{
	remove(tempfile);
}

/* 
 *    main()  modified on  11.30 1995  
 */

main(argc,argv)
int argc;
char *argv[];
{
void printHelp_l();
void gen_out_name();
void make_file_list();
void init_m();
int  writeNodes();
PTR_BFND bfnd;
PTR_BLOB blob;
PTR_SYMB symb;
char	*tmpoutfile;
char    fpp_path1[200],fpp_path2[200];
int	  status;
char     command[1000];
extern int outer_scope;

if((argc==1)||(argc>4))
	{
        printHelp_l();
	exit(0);
	}
else
     {
	argv++;
        while ((argc > 1) && (*argv)[0] == '-')
	   {
        if(strcmp(argv[0],"-d")==0)
                   debugFlag_g=1;
        else
	    if (strcmp(argv[0],"-i")==0)
			intrFlag_g=1;
	    else
	    if (strcmp(argv[0],"-c")==0)
			cc_flag=1;
	    else
		   printHelp_l();
            argc--;
            argv++;
            }
	}
if (*argv)
     input_file = *argv;
else 
    {
     printf(" * No input_file \n");
     exit(0);
	}

/*  fpp to preprocess the include .added by zheng.gb 1996/11/29 */
#ifdef STDC_HEADERS
atexit(clear_tmp);
#endif
sprintf(fpp_path1,"%s/src/hpf2dep/fpp",SRCDIR);
sprintf(fpp_path2,"%s/fpp",LIBDIR);
tempfile=tempnam(NULL,"tmp");
sprintf(command,"if test -f %s ;then /bin/sh %s %s %s ;else /bin/sh %s %s %s ; fi",fpp_path1,fpp_path1,input_file,tempfile,fpp_path2,input_file,tempfile);
/* printf("command:%s\n",command); for debug??? zgs */
status=system(command);
if (WIFEXITED(status)) {
  status=WEXITSTATUS(status);
  if (status > 1)                 /*  exist error here in fpp */
	exit (1);
  else if (status ==1)            /* tmpfile is null, use input_file directly */
	tmpoutfile=input_file;
  else if (status == 0)           /* tmpfile is created */ 
	tmpoutfile=tempfile;
}
else
	exit (1);

/* use the output file processed by FPP : tmpoutfile to parse now */
if ((inf_ptr=fopen(tmpoutfile,"r")) == NULL)
        {
        printf(" * Can't open the input_file '%s'\n",input_file);
        exit(0);
        }
gen_out_name(input_file);
if(debugFlag_g==1)
	printf("input_file: %s , out_put_file:%s\n",input_file,outname);


init_m();
make_file_list(input_file);
global_bfnd->filename=cur_thread_file;

if (debugFlag_g==1)
	printf("main.c: The yyparse is beginning from here !\n");
lineNum_g=1;
lineNum_l=1;
                    /* by zheng.gb 1996.5.5 */
/*
bfnd=makeProgram(fi,SMNULL); 
add_scope_level(bfnd,NON);
outer_scope=1; 
*/ /* xli 3/12/97 */

yyparse();
                    /* by zheng.gb 1996.5.6 , end process */
/*
blob=global_bfnd->entry.Template.bl_ptr1;
if (blob->next == BLNULL) 
	global_bfnd->entry.Template.bl_ptr1= BLNULL;
else  {
	for ( ;blob->next->next;blob=blob->next);
   	blob->next=BLNULL;
}
cur_file->num_blobs--;
bfnd=cur_file->head_bfnd;
if (bfnd->thread == BFNULL)
	cur_file->head_bfnd=BFNULL;
else {
	for (; bfnd->thread->thread ; bfnd=bfnd->thread);
	bfnd->thread=BFNULL;
}
cur_file->num_bfnds--;
symb=cur_file->head_symb;
if (symb->thread == SMNULL)
        cur_file->head_symb=SMNULL;
else {
        for (; symb->thread->thread ; symb=symb->thread);
        symb->thread=SMNULL;
}
cur_file->num_symbs--;
*/  /* xli 3/12/97 */

if((debugFlag_g==1)&&(globeErr_g==0))
    printf("main.c: The yyparse ends here; And writeNodes begins!\n");

if(globeErr_g==0) 
    globeErr_g = writeNodes(cur_file,outname);

if(globeErr_g==0)
    printf("___Your JAVA program passed!___\n");

#ifdef  WANT_LIST
writeList(input_file,lstname);
#endif

remove(tempfile); 		/* remove the temperary file produced by fpp */

exit(globeErr_g?1:0);
}


void 
printHelp_l()
{
        printf("Usage: java2dep [-d] javafile.java \n");
        printf("       -d : debugging parser \n");
}

/*  
 *  "gen_out_name" gives the name of .dep file. It comes from sage++.
 */

void
gen_out_name (filename)
char *filename;
{
   register int    i;
   char *q, *r,*lst;
   int flag=0;

   if (!filename)
     return;

   outname = (char *) malloc((unsigned)(strlen(filename)+4));
   lstname = (char *) malloc((unsigned)(strlen(filename)+4));

   strcpy (outname,filename);
   strcpy (lstname,filename);

   for (i = strlen(filename)-1 ; i >= 0 ; i --)
   {
        if ( filename[i] == '.' )
        {
           if(filename[i+1]!='j')    /* this is added by Lxy (12/20/1995) */
              {
               printf(" * Input file should be  *.java \n");
               exit(0);
               }
	   flag=1;
           q = &(outname[i+1]);
	   lst = &(lstname[i+1]);
           break;
        }
   }
   if(flag==1)
     {
      r = q;
      *r++ = 'd';
      *r++ = 'e';
      *r++ = 'p';
      *r++ = '\0';
      r = lst ;
      *r++ = 'l';
      *r++ = 's';
      *r++ = 't';
      *r++ = '\0';
      }
   else 
     {
      printf(" * Input file should be  *.java \n");
      exit(0);
      }
}


void 
init_m()
{
/* void setimpl(); */
void initLblStack();

   lineNum_g=0;
   lineNum_l=0;
   globeErr_g=0;
   pred_bfnd = BFNULL;      /* used in finding the predecessor */
   last_bfnd = BFNULL;
   cur_blob = BLNULL;
   head_file = (PTR_FNAME)NULL;

   cur_file = fi = (PTR_FILE) calloc(1, (unsigned)sizeof(struct file_obj));
   language=2;
   fi->lang = language;
   fi->global_bfnd = global_bfnd = makeBfnd(fi,GLOBAL);
   global_bfnd->checked=SOFT;
   global_bfnd->filename=(PTR_FNAME)NULL;
   cur_blob = global_bfnd->entry.Global.control
                 = make_blob (fi,BFNULL, BLNULL);
   pred_bfnd = global_bfnd;

   init_scope_table();
   make_symb(fi,DEFAULT,"*");

   global_int      = make_type(fi,T_INT);
   global_float    = make_type(fi,T_FLOAT);
   global_double   = make_type(fi,T_DOUBLE);
   global_char     = make_type(fi,T_CHAR);
   global_string   = make_type(fi,T_STRING);
   global_bool     = make_type(fi,T_BOOL);
   global_complex  = make_type(fi,T_COMPLEX);
   global_dcomplex = make_type(fi,T_DCOMPLEX);
   global_default  = make_type(fi,DEFAULT);
 
   global_byte     = make_type(fi,T_BYTE);
   global_short    = make_type(fi,T_SHORT);
   global_long     = make_type(fi,T_LONG);

   derivedTypeFlag_g=0;

   containsNum_g=0;

   implicitNone_g=YES;

   lastBranchEnd = BLNULL;
   initLblStack(); /*Initialize the label stack used for label-do structure*/

/*   keyword_flag=ON;     zheng.gb */
}

/*
 *  make_file_list comes from sage++/f2dep/cftn.c.
 *  it is used as list the files of a project and
 *  set the cur_thread_file.
 */

void
make_file_list(filename)
char *filename;
{
   char  *namep = (char *) malloc((unsigned)(strlen(filename)+1));
   PTR_FNAME this = (PTR_FNAME) malloc((unsigned)sizeof(struct file_name));
   PTR_FNAME p;

   (void)strcpy(namep, filename);
   this->id = fi->num_files = ++num_files;
   this->name = namep;
   this->next = (PTR_FNAME)NULL;
   if (head_file == (PTR_FNAME)NULL)
      fi->head_file = head_file = this;
   else {
      for (p = head_file; p->next != NULL; p = p->next)
         ;
      p->next = this;
   }
   cur_thread_file = this;
}


/*
 *  writeNodes is similar with write_nodes in sage++.
 *  It is writen by Gu Zhaojun .
 */

/*************************************************************************

	writeList(name)
		output file to a  .lst file

by Zheng Gengbin
*************************************************************************/
int writeList(inputfile,outputname)
char *inputfile,*outputname;
{
	FILE *rfp,*wfp;
	char buf[256];
	int  no;

	if ((rfp=fopen(inputfile, "r"))==NULL) {
		printf("Input file: %d cannot open for reading .\n",inputfile);
		return 0;
	}
	if ((wfp=fopen(outputname, "w"))==NULL) {
		printf("List file: %d cannot open for writing .\n",outputname);
		return 0;
	}
	no = 1;
	while (fgets(buf, sizeof(buf)-1, rfp)!=NULL)
        {
		fprintf(wfp,"%6d   %s",no++,buf);
        }
	fprintf(wfp,"$f %s",inputfile);

	fclose(rfp);
	fclose(wfp);
}
