      PROGRAM HPF_3_10_1

      INTEGER,PARAMETER :: N=1000
      REAL,PARAMETER    :: H=1.0/N
      REAL              :: PI
      REAL,DIMENSION(N) :: RECT_AREA
!HPF$ DISTRIBUTE (CYCLIC) :: RECT_AREA

      
      INTERFACE 
         SUBROUTINE PRINT_RESULT(X)
           REAL :: X
         END SUBROUTINE PRINT_RESULT
      END INTERFACE

      FORALL (I=1:N)
         RECT_AREA(I)=H*F(H*(I-0.5))
      END FORALL
 
      PI = SUM(RECT_AREA)
      
      CALL PRINT_RESULT(PI)

      CONTAINS

       REAL PURE FUNCTION F(X)
           REAL, INTENT(IN) :: X
           F = 4/(1.0 + X*X)
       END FUNCTION F

       END PROGRAM HPF_3_10_1
