       PROGRAM HPF_6_3
       INTEGER :: I,J,M,N

        INTERFACE
               PURE INTEGER FUNCTION MANDELBROT(X)
                       COMPLEX,INTENT(IN) :: X
               END FUNCTION MANDELBROT
       END INTERFACE

       FORALL (I= 1:N,J =1:M)
        A(I,J) = MANDELBROT(CMPLX((I-1)*1.0/(N-1),(J-1)*1.0/(M-1)))
       END FORALL

       END  PROGRAM HPF_6_3


       PURE INTEGER FUNCTION MANDELBROT(X)

         COMPLEX ,INTENT(IN) :: X
         COMPLEX             :: XTMP
         INTEGER             :: K,ITOL
         K = 0
         XTMP = -X
         DO WHILE (ABS(XTMP) < 2.0 .AND. K<ITOL)
           XTMP = XTMP * XTMP -X
           K= K+1
         END DO
	END  FUNCTION MANDELBROT
